	program PREP          
c
C       THE PROGRAM PREPARES THE SAMPLING ACCORDING TO FAST
C
C	IT ALLOWS REGROUPING OF FACTORS
C
c	latest version 11/12/1998  by Stefano TARANTOLA
C
C-----------------------------------------------------------------------
C       INPUTS:   
C		./***/INPUTDATA.INP	VARIOUS SETTINGS
C		./par.h			PROGRAM'S PARAMETERS
C		./***/pdf.h		FACTORS' RANGES AND DISTRIB. 
C
C	OUTPUT:  
C		./prep.out		MODEL INPUTS
C-----------------------------------------------------------------------
C
      IMPLICIT REAL (A-H,P-Z)
      INTEGER OM,OMI,OMGRCI,OMGRI,OMIMAX,OMIMIN,HH,OMCIMAX,R,OMGRP,GR            
 
      INCLUDE 'par.h'
      INCLUDE 'cparam.h'                                                        
      INCLUDE 'cvaria.h' 
      INCLUDE 'cfast.h'
      include 'ctime.h'                                                      
      INCLUDE 'cspop.h'                                                            
      
      DIMENSION OM(MXNVAR),OMGRI(MXNVAR),OMGRCI(MXNVAR),
     +		NELGRP(MXNGRP), 
     +          matranks(MXNVAR,MXNRUN),	!matrix 
     +          FI(MXNVAR),			!phase shift
     +          GR(MXNGRP,MXNVAR)		!partition of factors into groups

	character*20 fn1,fn2,adum

c        INCLUDE './g_function/inputdata.inp'      
c	include './g_function/pdf.h'
c        INCLUDE './rosanna/inputdata.inp'      
c	include './rosanna/pdf.h'
        INCLUDE './prova/inputdata.inp'      
	include './prova/pdf.h'

C        INCLUDE './fish/inputdata.inp'      
C	include './fish/pdf.h'

	PI=4*DATAN(1.D0)      

C       COMPUTATION  OF SAMPLE SIZE

	NRUNS=2*MI*OMI+1      
	NT=NRUNS*NR      
	write(*,11) NT
11	format(1x,'Number of samples per factor ---> ',i5)
 
	IF (NRUNS.GT.MXNRUN) THEN
          WRITE(*,*)'Warning: NRUNS>MXNRUN! Choose MXNRUN greater'  
          STOP
	END IF

	ISEED=7407

	DITR=0.0027	  !distribution truncation	

	CALL EQUDIV

	DO HH=1,NP       !repeat the experiment NP times
	  write(*,*) 'HH = ',hh
	  DO L=1,NGRPS    !loop on number of GROUPS
c	   L=1              !computations only on GROUP L

C
C         ALGORITHM FOR SELECTING THE SET OF FREQUENCIES 
C
	    KI=NELGRP(L)	!POPULATION OF GROUP OF INTEREST
	    KCI=NVARS-KI	!POPULATION OF THE COMPLEM. GROUP
	    OMCIMAX=OMI/(2.*MCI)
	    CALL SETFREQ(NVARS,KCI,OMCIMAX,OMGRCI)
C
C	    OMGRCI(I), I=1,KCI CONTAINS THE SET OF FREQUENCIES 
C	    TO BE USED FOR THE COMPLEMENTARY GROUP 
C
c	    SETTING THE VECTOR OF FREQUENCIES 'OM' FOR THE 'NVARS' FACTORS
c
	    DO I=1,KI	!FOR THE GROUP OF INTEREST
	      OM(GR(L,I))=OMI
	    END DO
	    II=1		!FOR THE COMPL GROUP
	    DO NG=1,NGRPS
	      IF(NG.NE.L) THEN
	        DO I=1,NELGRP(NG)
	          OM(GR(NG,I))=OMGRCI(II)
	          II=II+1
	        END DO
	      END IF
	    END DO
	    WRITE(*,*) OM
        
            DO R=1,NR 		!number of search-curves within K^n
          
              DO J=1,NVARS
                FI(J)=RAN1(ISEED)*2*PI    
              END DO    
                            
              CALL PARCOMB2(OM,FI,MATRANKS)          
              DO    NRUN = 1, NRUNS                                              

	        CALL ASSIGN(matranks)  !output ---> xvar(nvars)

	        WRITE(55,12)  NRUN,(XVAR(NVAR),NVAR=1,2)  	   
12		FORMAT(1X,I4,2(1PE11.3))              
              END DO   !NRUN=1,NRUNS

	    END DO  !R=1,NR        

	  END DO    !L=1,NGRPS       

	END DO     !HH=1,NP    	                 	
	CLOSE(55)
	stop
	END
