       program SPOP
          
C       TOTAL EFFECTS AND FIRST ORDER INDICES COMPUTED WITH FAST
C	FROM THE SET OF MODEL OUTPUTS GIVEN IN FILE "SPOP.INP"
C
C----------------------------------------------------------------------
C       INPUT:   SPOP.INP	
C
C	OUTPUT:  FIRST ORDER and TOTAL SENSITIVITY INDICES --->
C                --->  ./s192.6 (e.g.)
C               
C-----------------------------------------------------------------------
C
      IMPLICIT REAL (A-H,P-Z)
      INTEGER OMI,P,Q,HH,R,GR
      REAL  M1,M2
      character*3 iduma
	 
      INCLUDE 'par.h'
      
      DIMENSION 
     +		NELGRP(MXNGRP), 
     +          AC(MXNRUN),BC(MXNRUN),			!Fourier Coefficients
     +          ADCI(MXNTIM,MXNCHN),
     +          AD(MXNTIM,MXNCHN),
     +          DCI(MXNTIM,MXNCHN),			! part. var. of the compl. set of par.
     +          D(MXNTIM,MXNCHN),			! total output variance
     +          STI(MXNVAR,MXNTIM,MXNCHN),		! total effect sens. index
     +          ADI(MXNTIM,MXNCHN),
     +          DI(MXNTIM,MXNCHN),			! part. variance of par. i
     +          SI(MXNVAR,MXNTIM,MXNCHN),		! first order sens. index
     +          GR(MXNGRP,MXNVAR),			! partition of parameters into groups
     +          U(MXNRUN),				! model output (single time)
     +		TOUT(MXNTIM),
     +		UU(MXNTIM,MXNCHN,MXNRUN)		! model output matrix     

        INCLUDE './lot20/inputdata.inp'      
        IOUT=MXNTIM
	open(unit=22,file='timevalues2.dat')
	READ(22,*) (TOUT(I), I=1,IOUT)
	close(22)        

	PI=4*DATAN(1.D0)
      
C       COMPUTATION  OF SAMPLE SIZE

      NRUNS=2*MI*OMI+1      
      NQ=(NRUNS-1)/2
      N0=NQ+1
      NT=NRUNS*NR      

      DO HH=1,NP       !repeat the experiment NP times
        DO L=1,NGRPS    !loop on number of GROUPS
c	L=1

C	Inizialisation matrices ADCI,DCI        

          DO ITIME=1,IOUT
            DO NCHAIN=1,MXNCHN
              ADCI(ITIME,NCHAIN)=0.
              ADI(ITIME,NCHAIN)=0.
              AD(ITIME,NCHAIN)=0.
            END DO
          END DO        

	DO R=1,NR 	!number of search-curves within K^n

C	READING MODEL OUTPUTS FROM FILE

	  DO NRUN = 1, NRUNS                                             
	    DO NCHAIN=1,MXNCHN
	      DO ITIME=1,IOUT            
	        READ(50,*) iduma,idum
                READ(50,*) dum,UU(ITIME,nchain,NRUN),dum
	      END DO   !ITIME=1,IOUT
	    END DO   !NCHAIN
          END DO   !NRUN
	
	  DO ITIME=1,IOUT
	    DO NCHAIN=1,MXNCHN
	      M1=0.D0
	      DO NRUN = 1, NRUNS         
	        U(NRUN)= UU(ITIME,nchain,NRUN)
	        M1=M1+U(NRUN)
	      END DO
	      M1=M1/NRUNS
	      
C	SUBTRACTING THE AVERAGE VALUE              
       	      DO NRUN=1,NRUNS
       	        U(NRUN)=U(NRUN)-M1
       	      END DO
C-----------------------------------------
C     COMPUTATION OF FOURIER COEFFICIENTS
C-----------------------------------------
C        
C     Fourier coeff. in  [1,\om/2] or [1,MCI*OMCIMAX]
C
	    COMPL=0.D0
            DO J=1,OMI/2
              AC(J)=0.D0
              BC(J)=0.D0
              SP1=U(N0)
              SP2=0.D0
              DO Q=1,NQ
                SP1=SP1+(U(N0+Q)+U(N0-Q))*DCOS(1.*J*2.D0*Q*PI/NRUNS) 
                SP2=SP2+(U(N0+Q)-U(N0-Q))*DSIN(1.*J*2.D0*Q*PI/NRUNS)
              END DO
              AC(J)=SP1/NRUNS
              BC(J)=SP2/NRUNS
c              WRITE(20,15) J,AC(J)**2+BC(J)**2                    
C
C      COMPUTATION OF D_{(-I)}
C            
              COMPL=COMPL+AC(J)**2+BC(J)**2
            END DO
            DCI(ITIME,NCHAIN)=2*COMPL
            ADCI(ITIME,NCHAIN)=ADCI(ITIME,NCHAIN)+DCI(ITIME,NCHAIN)
C
C     Fourier coeff. at [P*OMI, for P=1,MI]
C
            COMPL=0.D0
            DO P=1,MI
              J=P*OMI
              AC(J)=0.D0
              BC(J)=0.D0
              SP1=U(N0)
              SP2=0.D0
              DO Q=1,NQ
                SP1=SP1+(U(N0+Q)+U(N0-Q))*DCOS(1.*J*2.D0*Q*PI/NRUNS) 
                SP2=SP2+(U(N0+Q)-U(N0-Q))*DSIN(1.*J*2.D0*Q*PI/NRUNS)
              END DO
              AC(J)=SP1/NRUNS
              BC(J)=SP2/NRUNS
C
C      COMPUTATION OF D_I
C
              COMPL=COMPL+AC(J)**2+BC(J)**2
            END DO
            DI(ITIME,NCHAIN)=2*COMPL
            ADI(ITIME,NCHAIN)=ADI(ITIME,NCHAIN)+DI(ITIME,NCHAIN)
C
C        COMPUTATION OF THE TOTAL VARIANCE IN THE TIME DOMAIN
C 
           
            M2=0.D0
            DO J=1,NRUNS
              
              M2=M2+U(J)**2
            END DO                       
            D(ITIME,NCHAIN)=M2/(NRUNS-1)
	    AD(ITIME,NCHAIN)=AD(ITIME,NCHAIN)+D(ITIME,NCHAIN)
	  END DO  ! NCHAIN=1,MXNCHN        

        END DO  ! ITIME=1,IOUT
                
      END DO  !R=1,NR        

C-------------------------------------
C     COMPUTE SENSITIVITY INDICES
C-------------------------------------
      DO ITIME=1,IOUT
        DO NCHAIN=1,MXNCHN
          AD(ITIME,NCHAIN)=AD(ITIME,NCHAIN)/NR               
          ADI(ITIME,NCHAIN)=ADI(ITIME,NCHAIN)/NR
          ADCI(ITIME,NCHAIN)=ADCI(ITIME,NCHAIN)/NR
	  SI(L,ITIME,NCHAIN)=ADI(ITIME,NCHAIN)/AD(ITIME,NCHAIN)
	  STI(L,ITIME,NCHAIN)=1.-ADCI(ITIME,NCHAIN)/AD(ITIME,NCHAIN)
          write(81,12) L,SI(L,ITIME,NCHAIN),STI(L,ITIME,NCHAIN)
        END DO
      END DO
      
15      FORMAT(1X,I5,2X,1PE12.5)        
12	FORMAT(1X,I4,2(1F12.5))   	  		    	    	                       
      END DO    !L=1,NGRPS       
      END DO     !HH=1,NP    	                 
      stop
      END
